#{extends 'border.html'/}

<div class="container">
#{form @katalog.PermohonanPembaruanCtr.createSubmitWilayahJual(), method:'POST', class:'form-horizontal save', enctype:'multipart/form-data', id: 'fomWilayah'}
    <div class="row">
        <div class="col-md-12">
            <!-- Breadcrumb -->
            <ol class="breadcrumb">
                <li><a href="@{PublikCtr.home()}">&{'beranda.label'}</a></li>
                <li><a href="@{katalog.PermohonanPembaruanCtr.index()}">&{'permohonan_pembaruan.label'}</a></li>
                <li class="active">&{'edit.label'} &{'data.label'} &{'produk.label'} &{'wilayah_jual.label'}</li>
            </ol>
            <!-- End Breadcrumb -->
        </div>
    </div>

    <!-- Toolbar -->
    <div class="row">
        <div class="col-md-12">
            <div class="toolbar">
                #{backButton action:@katalog.PermohonanPembaruanCtr.index()/}
                <button type="submit" name="simpan" class="btn btn-md btn-primary" >Selanjutnya <i class="fa fa-arrow-circle-right"></i></button>
            </div>
            #{alert /}
        </div>
    </div>
    <!-- End Toolbar -->

    <div class="row">
        <div class="alert-container"></div>
        <div class="panel panel-default">
            <div class="panel-body">
                <div class="row">
                    <div class="col-md-12">
                        <div class="wilayah-wrapper">
                            <div class="wilayah-list row">
                                <div class="col-md-12">
                                    <button type="button" class="btn btn-primary" id="checkAll">&{'centang.label'} &{'semua.label'}</button>
                                </div>
                            </div>
                        </div>
                        <input type="hidden" id="checked-locations-bak" name="model.checkedLocations.bak" value="${produk?.produkHarga?.checked_locations_json}">
                        <input type="hidden" id="checked-locations" name="checked_Locations" value="${produkHarga?.checked_locations_json}">
                    </div>
                </div>
            </div>
        </div>
    </div>
    <input type="hidden" id="pmbid" name="pmbid" value="${pmb?.id}">
    <input type="hidden" id="ids" name="ids" value="[]">
#{/form}
</div>

#{set 'moreScripts'}
<script type="text/javascript" src="@{'public/javascripts/toast/jquery.toast.min.js'}"></script>
<script type="text/javascript" src="@{'public/javascripts/bootstrap-notify.min.js'}"></script>

<script type="text/javascript">
    //define variabel
    var tempJson = {};
    var params = {};
    var xlsJson = {};
    var checkLocations = {};
    const MODE_PRICE = 'price';
    const MODE_COST = 'cost';
    var checked = false;

    //explain variabel and set
    params['getKabByProvUrl'] = '@{controllers.katalog.ProdukCtr.getKabByProv()}';
    params['getAllKabAllProv'] = '@{controllers.katalog.ProdukCtr.getAllKabAllProv()}';
    params['priceClass'] = '${komoditas?.kelas_harga}';
    params['priceCoverage'] = '@{controllers.katalog.ProdukCtr.getProvOrKab()}';

    tempJson[MODE_PRICE] = [];
    tempJson[MODE_COST] = [];

    tempJson[MODE_PRICE] = [];
    tempJson[MODE_COST] = [];

    checkLocations.province = {};
    checkLocations.regency = {};

    String.prototype.replaceAll = function(search, replacement) {
        var target = this;
        return target.replace(new RegExp(search, 'g'), replacement);
    };

    function generateProvinsiList(prov, kelasHarga){

        var panel = $(document.createElement("div")).addClass("panel panel-default")
        var panel_heading = $(document.createElement("div")).addClass("panel-heading");
        var panel_head_row = $(document.createElement("div")).addClass("row");
        var wilayah_prov_item = $(document.createElement("div")).addClass("wilayah-prov-item");
        var prov_item_checkbox_div = $(document.createElement("div")).addClass("col-md-10");
        var prov_checkbox =$(document.createElement("div")).addClass("checkbox");
        var prov_checkbox_label = $(document.createElement("label"));
        var prov_checkbox_input = $(document.createElement("input"));
        var prov_checkbox_span = $(document.createElement("span"));

        prov_checkbox_input.attr("type","checkbox");
        prov_checkbox_span.html(prov.nama_provinsi);
        prov_checkbox_input.attr("prov",removeSpaceFromStr(prov.nama_provinsi));
        prov_checkbox_input.attr("provName",prov.nama_provinsi);
        prov_checkbox_input.attr("data-type", 1);
        prov_checkbox_input.attr("checked", checkLocations.province.hasOwnProperty(checkedKey(prov.id)));
        prov_checkbox_input.val(prov.id);
        if(kelasHarga === "provinsi"){
            prov_checkbox_input.attr("name","wilayah_jual");
            prov_checkbox_input.addClass("wilJualItems");
        }else{
            prov_checkbox_input.addClass("checkAllKab");
        }

        prov_checkbox_label.append(prov_checkbox_input);
        prov_checkbox_label.append(prov_checkbox_span);

        prov_checkbox.append(prov_checkbox_label);
        prov_item_checkbox_div.append(prov_checkbox);
        wilayah_prov_item.append(prov_item_checkbox_div);

        if(kelasHarga === "kabupaten" && (prov.kabupatens != null || prov.kabupatens.length > 0)){
            var prov_item_arrow_div = $(document.createElement("div")).addClass("col-md-1");
            var anchor = $(document.createElement("a")).addClass("collapsed");
            var anchor_icon = $(document.createElement("i")).addClass("fa fa-angle-down");


            anchor.attr("href","#"+removeSpaceFromStr(prov.nama_provinsi));
            anchor.attr("data-toggle","collapse");
            anchor.attr("aria-expanded","false");
            anchor.attr("aria-controls",prov.nama_provinsi);

            anchor.append(anchor_icon);

            prov_item_arrow_div.append(anchor);
            wilayah_prov_item.append(prov_item_arrow_div);
        }

        panel_head_row.append(wilayah_prov_item);
        panel_heading.append(panel_head_row);
        panel.append(panel_heading);

        return panel;
    }

    function generateKabupatenList(prov){
        var item_div = $(document.createElement("div")).addClass("collapse panel-collapse").attr("id",removeSpaceFromStr(prov.nama_provinsi));
        $.each(prov.kabupatens, function(index, kab){

            var wilayah_kab_item = $(document.createElement("div")).addClass("wilayah-kab-item");

            var kab_checkbox =$(document.createElement("div")).addClass("checkbox");
            var kab_checkbox_label = $(document.createElement("label"));

            var kab_checkbox_input = $(document.createElement("input")).addClass(removeSpaceFromStr(prov.nama_provinsi) +" wilJualItems");
            kab_checkbox_input.attr("type","checkbox");
            kab_checkbox_input.attr("name","wilayah_jual");
            kab_checkbox_input.attr("kabName",kab.nama_kabupaten);
            kab_checkbox_input.attr("provName",prov.nama_provinsi);
            kab_checkbox_input.attr("data-type", 2);
            kab_checkbox_input.val(kab.id);
            kab_checkbox_input.attr("checked", checkLocations.regency.hasOwnProperty(checkedKey(kab.id)));
            var kab_checkbox_span = $(document.createElement("span"));
            kab_checkbox_span.html(kab.nama_kabupaten);

            kab_checkbox_label.append(kab_checkbox_input);
            kab_checkbox_label.append(kab_checkbox_span);

            kab_checkbox.append(kab_checkbox_label);
            wilayah_kab_item.append(kab_checkbox);

            item_div.append(wilayah_kab_item);
        });

        return item_div;
    }

    function regenerateCheckedLocationValues() {
        var json = $('#checked-locations').val();
        if (json !== '') {
            checkLocations = JSON.parse(json);
        }
    }

    function generateWilayahJualList(data, kelasHarga){

        $.each(data, function(index, prov){
            var col = $(document.createElement("div")).addClass("col-md-4");
            var div = $(document.createElement("div")).addClass("wilayah-list-item");
            var panel = generateProvinsiList(prov, kelasHarga);

            if(kelasHarga == "kabupaten" && (prov.kabupatens != null || prov.kabupatens.length > 0)){
                var item_div = generateKabupatenList(prov);
                panel.append(item_div);
            }

            col.append(div);
            div.append(panel);
            $(".wilayah-list").append(col);
        });
    }

    function insertCheckedLocations(model) {
        var isChecked = model.prop('checked');
        var value = model.val();
        if (model.data('type') == 1) {
            if (isChecked) {
                if (!checkLocations.province.hasOwnProperty(value)) {
                    checkLocations.province[checkedKey(value)] = true;
                }
            } else {
                if (checkLocations.province.hasOwnProperty(value)) {
                    delete checkLocations.province[checkedKey(value)];
                }
            }
        } else {
            if (isChecked) {
                if (!checkLocations.regency.hasOwnProperty(value)) {
                    checkLocations.regency[checkedKey(value)] = true;
                }
            } else {
                if (checkLocations.regency.hasOwnProperty(value)) {
                    delete checkLocations.regency[checkedKey(value)];
                }
            }
        }
    }

    function generateCheckedJson() {
        $(".wilayah-list-item input[type=checkbox]").each(function () {
            insertCheckedLocations($(this));
        });
        $('#checked-locations').val(JSON.stringify(checkLocations));
    }

    function setToXlsJson() {
        $("#xls-json").val(JSON.stringify(xlsJson));
    }

    function createCheckedLocation(){
        if(params.priceClass === 'kabupaten' || params.priceClass === 'provinsi'){
            $.ajax({
                type:'GET',
                url: params.priceCoverage,
                dataType:'json',
                success:function(data){
                    regenerateCheckedLocationValues();
                    generateWilayahJualList(data, params.priceClass);

                    //set checked existing
                    var valuec = collectChecked();
                    $('#ids').val(JSON.stringify(valuec));
                },
                error: function (e) {
                    alert("error:"+params.priceCoverage);
                }
            });
        }else{
            //alert("else");
        }
    }

    function removeSpaceFromStr(str){
        return str.replaceAll(" ","");
    }

    function checkedKey(value) {
        //return "'" + value + "'";
        return "" + value + "";
    }

    function collectChecked(){
        var checkedItems = $(".wilJualItems:checkbox:checked");
        var ids = new Array();
        checkedItems.each(function () {
            var item = $(this);
            var provInfo = {};

            if(params.priceClass === 'kabupaten'){
                provInfo['provId'] = item.val();
                provInfo['provName'] = item.attr("provname");
                provInfo['kabId'] = item.val();
                provInfo['kabName'] = item.attr("kabName");
            }else if(params.priceClass === 'provinsi'){
                provInfo['provId'] = item.val();
                provInfo['provName'] = item.attr("provname");
            }
            ids.push(provInfo);
        });
        return ids;
    }

    jQuery(document).ready(function () {
        createCheckedLocation();

        $("body").on("change", ".checkAllKab", function () {
            var prov = "."+$(this).attr("prov");
            $(prov).not(this).prop('checked', this.checked);
        });

        $("body").on("click", "#checkAll", function () {
            checked = !checked;
            $("input[type='checkbox']").not(this).prop('checked', checked);
        });

        //setToXlsJson();
        $('#fomWilayah').submit(function () {
            var valuec = collectChecked();
            $('#ids').val(JSON.stringify(valuec));
            generateCheckedJson();
        })
    });
</script>
#{/set}